Index: branches/UKMO/dev_r5518_obs_oper_update_sit/NEMOGCM/NEMO/OPA_SRC/ASM/asminc.F90
===================================================================
--- branches/UKMO/dev_r5518_obs_oper_update_sit/NEMOGCM/NEMO/OPA_SRC/ASM/asminc.F90	(revision 12557)
+++ branches/UKMO/dev_r5518_obs_oper_update_sit/NEMOGCM/NEMO/OPA_SRC/ASM/asminc.F90	(revision 12594)
@@ -994,9 +994,4 @@
       INTEGER  ::   it
       REAL(wp) ::   zincwgt   ! IAU weight for current time step
-! #if defined key_lim2
-!       REAL(wp), DIMENSION(jpi,jpj) ::   zofrld, zohicif, zseaicendg, zhicifinc  ! LIM
-!       REAL(wp) ::   zhicifmin = 0.5_wp      ! ice minimum depth in metres
-!       !!THICKNESS INCS NOT SET UP FOR LIM
-! #endif
       !!----------------------------------------------------------------------
 
@@ -1021,31 +1016,4 @@
             ENDIF
 
-            ! Sea-ice : LIM-3 case (to add)
-
-! #if defined key_lim2
-!             ! Sea-ice : LIM-2 case (to add if needed)
-!             zofrld (:,:) = frld(:,:)
-!             zohicif(:,:) = hicif(:,:)
-!             !
-!             frld  = MIN( MAX( frld (:,:) - seaice_bkginc(:,:) * zincwgt, 0.0_wp), 1.0_wp)
-!             pfrld = MIN( MAX( pfrld(:,:) - seaice_bkginc(:,:) * zincwgt, 0.0_wp), 1.0_wp)
-!             fr_i(:,:) = 1.0_wp - frld(:,:)        ! adjust ice fraction
-!             !
-!             zseaicendg(:,:) = zofrld(:,:) - frld(:,:)   ! find out actual sea ice nudge applied
-!             !
-!             ! Nudge sea ice depth to bring it up to a required minimum depth
-!             WHERE( zseaicendg(:,:) > 0.0_wp .AND. hicif(:,:) < zhicifmin ) 
-!                zhicifinc(:,:) = (zhicifmin - hicif(:,:)) * zincwgt    
-!             ELSEWHERE
-!                zhicifinc(:,:) = 0.0_wp
-!             END WHERE
-!             !
-!             ! nudge ice depth
-!             hicif (:,:) = hicif (:,:) + zhicifinc(:,:)
-!             phicif(:,:) = phicif(:,:) + zhicifinc(:,:)       
-!             !
-!             ! seaice salinity balancing (to add)
-! #endif
-
 #if defined key_cice && defined key_asminc
             ! Sea-ice thickness : CICE case. Pass ice thickness increment tendency into CICE
@@ -1076,31 +1044,4 @@
             neuler = 0                    ! Force Euler forward step
 
-            ! Sea-ice : LIM-3 case (to add)
-
-! #if defined key_lim2
-!             ! Sea-ice : LIM-2 case (add if needed)
-!             zofrld(:,:)=frld(:,:)
-!             zohicif(:,:)=hicif(:,:)
-!             ! 
-!             ! Initialize the now fields the background + increment
-!             frld (:,:) = MIN( MAX( frld(:,:) - seaice_bkginc(:,:), 0.0_wp), 1.0_wp)
-!             pfrld(:,:) = frld(:,:) 
-!             fr_i (:,:) = 1.0_wp - frld(:,:)                ! adjust ice fraction
-!             zseaicendg(:,:) = zofrld(:,:) - frld(:,:)      ! find out actual sea ice nudge applied
-!             !
-!             ! Nudge sea ice depth to bring it up to a required minimum depth
-!             WHERE( zseaicendg(:,:) > 0.0_wp .AND. hicif(:,:) < zhicifmin ) 
-!                zhicifinc(:,:) = (zhicifmin - hicif(:,:)) * zincwgt    
-!             ELSEWHERE
-!                zhicifinc(:,:) = 0.0_wp
-!             END WHERE
-!             !
-!             ! nudge ice depth
-!             hicif (:,:) = hicif (:,:) + zhicifinc(:,:)
-!             phicif(:,:) = phicif(:,:)       
-!             !
-!             ! seaice salinity balancing (to add)
-! #endif
- 
 #if defined key_cice && defined key_asminc
             ! Sea-ice thickness : CICE case. Pass ice thickness increment tendency into CICE
@@ -1119,79 +1060,4 @@
          
          ENDIF
-
-!#if defined defined key_lim2 || defined key_cice
-!
-!            IF (ln_seaicebal ) THEN       
-!             !! balancing salinity increments
-!             !! simple case from limflx.F90 (doesn't include a mass flux)
-!             !! assumption is that as ice concentration is reduced or increased
-!             !! the snow and ice depths remain constant
-!             !! note that snow is being created where ice concentration is being increased
-!             !! - could be more sophisticated and
-!             !! not do this (but would need to alter h_snow)
-!
-!             usave(:,:,:)=sb(:,:,:)   ! use array as a temporary store
-!
-!             DO jj = 1, jpj
-!               DO ji = 1, jpi 
-!           ! calculate change in ice and snow mass per unit area
-!           ! positive values imply adding salt to the ocean (results from ice formation)
-!           ! fwf : ice formation and melting
-!
-!                 zfons = ( -nfresh_da(ji,jj)*soce + nfsalt_da(ji,jj) )*rdt
-!
-!           ! change salinity down to mixed layer depth
-!                 mld=hmld_kara(ji,jj)
-!
-!           ! prevent small mld
-!           ! less than 10m can cause salinity instability 
-!                 IF (mld < 10) mld=10
-!
-!           ! set to bottom of a level 
-!                 DO jk = jpk-1, 2, -1
-!                   IF ((mld > gdepw(ji,jj,jk)) .and. (mld < gdepw(ji,jj,jk+1))) THEN 
-!                     mld=gdepw(ji,jj,jk+1)
-!                     jkmax=jk
-!                   ENDIF
-!                 ENDDO
-!
-!            ! avoid applying salinity balancing in shallow water or on land
-!            ! 
-!
-!            ! dsal_ocn (psu kg m^-2) / (kg m^-3 * m)
-!
-!                 dsal_ocn=0.0_wp
-!                 sal_thresh=5.0_wp        ! minimum salinity threshold for salinity balancing
-!
-!                 if (tmask(ji,jj,1) > 0 .AND. tmask(ji,jj,jkmax) > 0 ) &
-!                              dsal_ocn = zfons / (rhop(ji,jj,1) * mld)
-!
-!           ! put increments in for levels in the mixed layer
-!           ! but prevent salinity below a threshold value 
-!
-!                   DO jk = 1, jkmax              
-!
-!                     IF (dsal_ocn > 0.0_wp .or. sb(ji,jj,jk)+dsal_ocn > sal_thresh) THEN 
-!                           sb(ji,jj,jk) = sb(ji,jj,jk) + dsal_ocn
-!                           sn(ji,jj,jk) = sn(ji,jj,jk) + dsal_ocn
-!                     ENDIF
-!
-!                   ENDDO
-!
-!      !            !  salt exchanges at the ice/ocean interface
-!      !            zpmess         = zfons / rdt_ice    ! rdt_ice is ice timestep
-!      !
-!      !! Adjust fsalt. A +ve fsalt means adding salt to ocean
-!      !!           fsalt(ji,jj) =  fsalt(ji,jj) + zpmess     ! adjust fsalt  
-!      !!               
-!      !!           emps(ji,jj) = emps(ji,jj) + zpmess        ! or adjust emps (see icestp1d) 
-!      !!                                                     ! E-P (kg m-2 s-2)
-!      !            emp(ji,jj) = emp(ji,jj) + zpmess          ! E-P (kg m-2 s-2)
-!               ENDDO !ji
-!             ENDDO !jj!
-!
-!            ENDIF !ln_seaicebal
-!
-!#endif
 
       ENDIF